# The LoRa forwarder: `lorafwd`

The _LoRa forwarder_ is a user space daemon that forwards data from the
_LoRa daemon_ (through the _LoRa API_) to a _LoRa network server_.

## Build

If you get the sources from `git` the `protos/` directory should contains
`proto` files. But, in doubts, you can update the submodules with:

```bash
git submodule update --init --recursive
```

Then, the build requires a configuration file. You can create one by yourself
or create a default configuration file with:

```bash
make defconfig
```

The `.config` file may be edited later. All available options are described in
the `defconfig` file.

Finally, just run:

```bash
make
```

## Control channel

The _LoRa forwarder_ has its own control channel as described in the _LoRa API_.

The endpoint for the control channel can be configured at runtime. Check the
`lorafwd.toml` default configuration file.

The `lorafwd` control channel support these services:
 - Verbosity management: `"set_verbosity"`
 - Request for version: `"get_version"`
 - Request for statistics: `"get_statistics"`

### Available statistics

Statistics available on `lorafwd` are the following:

| Name | Type | Mandatory |
|--|--|--|
| uplink_forwarded | unsigned int | yes |
| uplink_sent | unsigned int | yes |
| uplink_acknowledged | unsigned int | yes |
| heartbeat_sent | unsigned int | yes |
| heartbeat_acknowledged | unsigned int | yes |
| downlink_received | unsigned int | yes |
| downlink_acknowledged | unsigned int | yes |

## License

This work is released under the [3-Clause BSD License](LICENSE.md).
