// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _FORWARDER_H_
#define _FORWARDER_H_

#include <chrono>
#include <cstddef>

#include "utils/service.h"

#include "api.h"
#include "config.h"
#include "database.h"
#include "filter.h"
#include "gwmp.h"

class Forwarder : public service::Service
{
public:
	Forwarder(const Config &_config,
		  API &_api,
		  Filter &_filter,
		  Database &_database,
		  GWMP &_gwmp);

	virtual bool start(void);

private:
	const Config &m_config;
	API &m_api;
	Filter &m_filter;
	Database &m_database;
	GWMP &m_gwmp;

	std::size_t m_dbLimitMessages;
	std::chrono::milliseconds m_dbCooldown;

	bool database(void);
	bool downlink(void);
	bool uplink(void);

	void acknowledge(void);
	void timeout(void);
};

#endif
