// Copyright (c) 2018 Kerlink SA. All rights reserved.

#include "message/container.h"

namespace message {
namespace downlink {
namespace {
struct DownlinkVisitor
{
	std::ostream &m_os;

	DownlinkVisitor(std::ostream &_os) : m_os{_os} {}

	template <typename T>
	void operator()(const T &_message)
	{
		m_os << _message;
	}
};
}

std::ostream &operator<<(std::ostream &_os, const Container &_message)
{
	mpark::visit(DownlinkVisitor(_os), _message.messages);

	return _os;
}
}

namespace {
struct UplinkVisitor
{
	std::ostream &m_os;

	UplinkVisitor(std::ostream &_os) : m_os{_os} {}

	template <typename T>
	void operator()(const T &_message)
	{
		m_os << _message;
	}
};
}

namespace uplink {
std::ostream &operator<<(std::ostream &_os, const Container &_message)
{
	mpark::visit(UplinkVisitor(_os), _message.messages);

	return _os;
}
}
}
