// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _MESSAGE_CONTAINER_H_
#define _MESSAGE_CONTAINER_H_

#include <ostream>

#include "third-party/variant.h"

#include "message/data.h"
#include "message/event.h"

namespace message {
namespace downlink {
struct Container
{
	Container(void) {}
	Container(const lora::Downlink &_message) : messages(_message) {}
	Container(const gfsk::Downlink &_message) : messages(_message) {}

	mpark::variant<lora::Downlink, gfsk::Downlink> messages;
};

std::ostream &operator<<(std::ostream &_os, const Container &_message);
}

namespace uplink {
struct Container
{
	Container(void) {}
	Container(const lora::Uplink &_message) : messages(_message) {}
	Container(const gfsk::Uplink &_message) : messages(_message) {}
	Container(const event::Uplink &_message) : messages(_message) {}

	mpark::variant<lora::Uplink, gfsk::Uplink, event::Uplink> messages;
};

std::ostream &operator<<(std::ostream &_os, const Container &_message);
}
}

#endif
