// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _STATISTICS_H_
#define _STATISTICS_H_

#include <cstdint>
#include <string>

struct Statistics
{
	std::uint32_t uplink_forwarded;
	std::uint32_t uplink_sent;
	std::uint32_t uplink_acknowledged;
	std::uint32_t heartbeat_sent;
	std::uint32_t heartbeat_acknowledged;
	std::uint32_t downlink_received;
	std::uint32_t downlink_acknowledged;
};

#ifdef DEPRECATED_FEATURES
struct LoradStatistics
{
	std::uint32_t uplink_received;
	bool has_uplink_received;
	std::uint32_t uplink_invalid;
	bool has_uplink_invalid;
	std::uint32_t uplink_valid;
	bool has_uplink_valid;
	std::uint32_t uplink_bytes_received;
	bool has_uplink_bytes_received;
	std::uint32_t downlink_requested;
	bool has_downlink_requested;
	std::uint32_t downlink_scheduled;
	bool has_downlink_scheduled;
	std::uint32_t downlink_transmitted;
	bool has_downlink_transmitted;
	std::uint32_t downlink_bytes_transmitted;
	bool has_downlink_bytes_transmitted;
	float gps_latitude;
	bool has_gps_latitude;
	float gps_longitude;
	bool has_gps_longitude;
	std::int32_t gps_altitude;
	bool has_gps_altitude;
	std::uint32_t gps_lost_pulse;
	bool has_gps_lost_pulse;
	float radio_temperature;
	bool has_radio_temperature;
	std::uint32_t version_fpga;
	bool has_version_fpga;
	std::uint32_t version_dsp;
	bool has_version_dsp;
	std::string version_hal;
	bool has_version_hal;
};
#endif

#endif
