// Copyright (c) 2018 Kerlink SA. All rights reserved.

#include "stream.h"

namespace utils {
template <>
ToHex<std::string> to_hex(const std::string &_value, std::size_t _width)
{
	std::size_t max = _value.size();
	return {_value, (_width) ? (_width < max) ? _width : max : max};
}

template <>
std::ostream &operator<<(std::ostream &_os, const ToHex<char> &_hex)
{
	return (_os << to_hex(static_cast<std::uint8_t>(_hex.value),
			      _hex.width));
}

template <>
std::ostream &operator<<(std::ostream &_os, const ToHex<std::string> &_hex)
{
	for (std::size_t i = 0; i < _hex.width; i++) {
		_os << to_hex(_hex.value[i]);
	}

	return _os;
}
}
