// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _UTILS_STRONG_TYPE_H_
#define _UTILS_STRONG_TYPE_H_

namespace utils {
template <typename T, typename Parameter>
class StrongType
{
public:
	StrongType() : m_value() {}
	StrongType(const T &_value) : m_value(_value) {}

	StrongType &operator=(const T &_value)
	{
		m_value = _value;
		return *this;
	}

	operator const T &() const { return m_value; }
	operator T &() { return m_value; }

	StrongType &operator=(const StrongType &_from)
	{
		m_value = _from;
		return *this;
	}

private:
	T m_value;
};
}

#endif
